#ifndef __EM_CALLBACK__
#define __EM_CALLBACK__
typedef void (*em_void_void_callback) (void);
#endif
#ifndef __EWG_SDL__
#define __EWG_SDL__

#include <SDL.h>
#include <SDL_image.h>
#include <SDL_mixer.h>
#include <SDL_rotozoom.h>
#include <SDL_framerate.h>
#include <SDL_gfxPrimitives.h>
#include <SDL_gfxPrimitives_font.h>
#include <SDL_mixer.h>
#include <SDL_ttf.h>

#ifdef _WIN32
#include <windows.h>
#endif
#include <GL/gl.h>
#include <GL/glu.h>

#include <stdlib.h>

#ifndef _WIN32
#include <gdk/gdkx.h>
#endif

// Fastevents and Net2
#include "../net2/fastevents.h"
#include "../net2/net2.h"

// GLSDK used to load glext.h
#include "glsdk.h"

#ifndef _WIN32
// used for EiffelMedia widget window hack
int get_gdk_window_xwindow (GdkDrawable* a_pointer);
#endif
#endif

#ifndef __AUDIO_MOVIE_DATA_STRUCT__
#define __AUDIO_MOVIE_DATA_STRUCT__
typedef struct {
	int playing;
	char* buffer;
	int size;
	int* start;
	int* end;
	char* empty;
} audio_movie_data_struct;

void add_audio_movie_stream_callback (audio_movie_data_struct *userdata);
#endif

/* audio event types */
#ifndef __AUDIO_FUNCTIONS__
#define __AUDIO_FUNCTIONS__
enum {

    AUDIO_CHANNELFINISHEDEVENT = 20,          // Fired on channel finished callback
    AUDIO_MUSICFINISHEDEVENT = 21,            // Fired on music finished callback
};

/* audio callback and event functions */
void audio_channel_finished_callback (int chan);
void add_audio_channel_finished_callback ();

void audio_music_finished_callback ();
void add_audio_music_finished_callback ();

int get_sdl_user_event_type (SDL_Event *e);
int get_audio_channel (SDL_Event *e);
#endif


//em_net-caster's used to transfer doubles and reals over the network

/*typedef struct {
	int w1, w2;
	} int_pair;*/

int cast_float_to_int(float f);
float cast_int_to_float(int i);
/*int_pair cast_double_to_long_int(double f);
double cast_long_int_to_double(int_pair i);
*/
